
float firex0;
float firey0;

// Texture to be drawn
Texture g_Tex;
sampler2D s = sampler_state {
	Texture = <g_Tex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// Fire Color Gradient
Texture fgrad_Map;
sampler2D Firegrad = sampler_state {
	Texture = <fgrad_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// Fire Pattern
Texture fpat_Map;
sampler2D Pattern = sampler_state {
	Texture = <fpat_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = WRAP;
	AddressV = WRAP;
};



float4 draw ( float2 texCoords : TEXCOORD0 ) : COLOR
{
    float4 c = tex2D(s, texCoords);
    
    float3 newc = float3(0,0,0);
    
    // Fire
    if(c.a > 0.0) {
        float f1 = tex2D(Pattern, 1.1*texCoords + float2(firex0, firey0)).r;
        float f2 = 1.0 - tex2D(Pattern, 1.41*float2(texCoords.x -0.6*firex0, 0.6*texCoords.y + 0.731*firey0)).r;
        newc = tex2D(Firegrad, float2(c.a - 0.8*(f1*f2), 0.5));
        newc = float3(newc.r*c.r, newc.g*c.g, newc.b*c.b);
    }
    
    return float4(newc.r, newc.g, newc.b, c.a);
}







technique Draw
{
	pass p0
	{
		Sampler[0] = <s>;
		Sampler[1] = <Firegrad>;
        Sampler[2] = <Pattern>;
		PixelShader = compile ps_2_0 draw();
	}
}
