
float waterx0;
float watery0;
float waterOffX;
float waterOffY;

// Texture to be drawn
Texture g_Tex;
sampler2D s = sampler_state {
	Texture = <g_Tex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

// Water Pattern
Texture pat_Map;
sampler2D Pattern = sampler_state {
	Texture = <pat_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = WRAP;
	AddressV = WRAP;
};

// Ice Pattern
Texture ice_Map;
sampler2D Ice = sampler_state {
	Texture = <ice_Map>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = WRAP;
	AddressV = WRAP;
};


float4 draw ( float2 texCoords : TEXCOORD0 ) : COLOR
{
    float4 c = tex2D(s, texCoords);
    
    float3 newc = float3(0,0,0);
    
    if(c.a > 0.0) {
        texCoords += float2(waterOffX, waterOffY);
        // Water
        if(c.g > 0) {
            // (Partly) Fluid
            float4 moved1 = tex2D(Pattern, float2(waterx0 + texCoords.x*2.1, watery0 + texCoords.y*3.1)); 
            float4 moved2 = tex2D(Pattern, float2(-0.72*waterx0 + texCoords.x*1.8, 0.4*watery0 + texCoords.y*2.71));
            float4 ice = tex2D(Ice, float2(texCoords.x*2, texCoords.y*3));
            newc = 0.5*c.g*(moved1 + moved2) + (1-c.g)*ice;
        } else {
            // Ice
            newc = tex2D(Ice, float2(texCoords.x*2,  texCoords.y*3));
        }
        // sharper alpha transition
        c.a = -4.0 + 10.0*c.a;
    }
    
    return float4(newc.r, newc.g, newc.b, c.a);
}







technique Draw
{
	pass p0
	{
		Sampler[0] = <s>;
        Sampler[1] = <Pattern>;
		PixelShader = compile ps_2_0 draw();
	}
}
